#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

struct segtree {
    ll sz;
    vector<ll> tr;

    segtree(ll N) {
        sz = N;
        tr.assign(N * 4, -INF);
    }

    void upd(ll x, ll l, ll r, ll idx, ll val) {
        if (l == r) {
            tr[x] = val;
            return;
        }
        ll mid = (r + l) / 2;
        if (idx <= mid) {
            upd(x * 2 + 1, l, mid, idx, val);
        }
        else {
            upd(x * 2 + 2, mid + 1, r, idx, val);
        }
        tr[x] = max(tr[x * 2 + 1], tr[x * 2 + 2]);
    }

    ll query(ll x, ll l, ll r, ll L, ll R) {
        if (r < l) {
            return -INF;
        }
        if (R < l) {
            return -INF;
        }
        if (r < L) {
            return -INF;
        }
        if (L <= l && r <= R) {
            return tr[x];
        }
        ll mid = (r + l) / 2;
        return max(query(x * 2 + 1, l, mid, L, R), query(x * 2 + 2, mid + 1, r, L, R));
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    vector<ll> v(n);
    map<ll, ll> mp;
    vector<segtree> sg(64, segtree(n));
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        mp[v[i]] = i;
        ll pos = v[i];
        deque<ll> up;
        deque<ll> down;
        ll mn = i;
        while (mp.count(pos / 2)) {
            pos /= 2;
            mn = min(mn, mp[pos]);
            down.push_back(mn);
        }
        pos = v[i];
        mn = i;
        while (mp.count(pos * 2)) {
            pos *= 2;
            mn = min(mn, mp[pos]);
            up.push_back(mn);
        }
        deque<ll> merged;
        merged.push_back(i);
        while (up.size() + down.size() > 0) {
            if (up.size() == 0) {
                merged.push_back(down[0]);
                down.pop_front();
            }
            else if (down.size() == 0) {
                merged.push_back(up[0]);
                up.pop_front();
            }
            else if (down[0] >= up[0]) {
                merged.push_back(down[0]);
                down.pop_front();
            }
            else {
                merged.push_back(up[0]);
                up.pop_front();
            }
        }
        for (int j = 0; j < merged.size(); j++) {
            // cout << merged[j] << ' ';
            sg[j].upd(0, 0, n - 1, i, merged[j]);
        }
        // cout << '\n';
    }
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        ll l = 0, r = 63;
        while (r > l) {
            ll mid = r - (r - l) / 2;
            if (sg[mid].query(0, 0, n - 1, x, y) >= x) {
                l = mid;
            }
            else {
                r = mid - 1;
            }
        }
        cout << l << '\n';
    }
}
